#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin>>t;
    for(int i=0;i<t;i++)
    {
        int rezultat=0;
        long long da,ne;
        cin>>da>>ne;
        long long daa[da];
        cin>>daa[0];
        cin>>daa[1];
        int raz=daa[1]-daa[0];
        int nzd=raz;
        for(int j=2;j<da;j++)
        {
            cin>>daa[j];
            raz=daa[j]-daa[j-1];
            nzd=__gcd(nzd,raz);
        }
        for(int j=0;j<ne;j++)
        {
            int x;
            cin>>x;
            if((daa[0]-x)%nzd==0)
            {
                rezultat++;
            }
        }
        if(rezultat==0)
        {
            cout<<1<<endl;
        }
        else
        {
            cout<<0<<endl;
        }
    }
    return 0;
}